| Version: 3.3.1

Public Member Functions | List of all members
wxTextDataObject Class Reference
Class List by Category » Clipboard and Drag & Drop

`#include <wx/dataobj.h>`

Inheritance diagram for wxTextDataObject:
[legend]

## Detailed Description

wxTextDataObject is a specialization of wxDataObjectSimple for text data.

It can be used without change to paste data into the wxClipboard or a wxDropSource. A user may wish to derive a new class from this class for providing text on-demand in order to minimize memory consumption when offering data in several formats, such as plain text and RTF because by default the text is stored in a string in this class, but it might as well be generated when requested, in which case GetText() should be overridden.

Note that if you already have the text inside a string, you will not achieve any efficiency gain by overriding these functions because copying wxStrings is already a very efficient operation (data is not actually copied because wxStrings are reference counted).

##

Library: wxCore
Category: Clipboard and Drag & Drop

See also
  Drag and Drop Overview, wxDataObject, wxDataObjectSimple, wxFileDataObject, wxBitmapDataObject

## Public Member Functions
| wxTextDataObject (const wxString &text=wxEmptyString)
| Constructor, may be used to initialise the text (otherwise SetText() should be used later). More...
virtual wxString | GetText () const
| Returns the text associated with the data object. More...
size_t | GetTextLength () const
virtual size_t | GetFormatCount (wxDataObject::Direction dir=wxDataObject::Get) const
| Returns 2 under wxMac and wxGTK, where text data coming from the clipboard may be provided as ANSI (`wxDF_TEXT`) or as Unicode text (`wxDF_UNICODETEXT`). More...
const wxDataFormat & | GetFormat () const
| Returns the preferred format supported by this object. More...
virtual void | GetAllFormats (wxDataFormat *formats, wxDataObject::Direction dir=wxDataObject::Get) const
| Returns all the formats supported by wxTextDataObject. More...
virtual void | SetText (const wxString &strText)
| Sets the text associated with the data object. More...
Public Member Functions inherited from wxDataObjectSimple
| wxDataObjectSimple (const wxDataFormat &format=wxFormatInvalid)
| Constructor accepts the supported format (none by default) which may also be set later with SetFormat(). More...
virtual bool | GetDataHere (void *buf) const
| Copy the data to the buffer, return true on success. More...
virtual size_t | GetDataSize () const
| Gets the size of our data. More...
const wxDataFormat & | GetFormat () const
| Returns the (one and only one) format supported by this object. More...
virtual bool | SetData (size_t len, const void *buf)
| Copy the data from the buffer, return true on success. More...
void | SetFormat (const wxDataFormat &format)
| Sets the supported format. More...
Public Member Functions inherited from wxDataObject
| wxDataObject ()
| Constructor. More...
virtual | ~wxDataObject ()
| Destructor. More...
virtual bool | GetDataHere (const wxDataFormat &format, void *buf) const =0
| The method will write the data of the format format to the buffer buf. More...
virtual size_t | GetDataSize (const wxDataFormat &format) const =0
| Returns the data size of the given format format. More...
virtual wxDataFormat | GetPreferredFormat (Direction dir=Get) const =0
| Returns the preferred format for either rendering the data (if dir is `Get`, its default value) or for setting it. More...
virtual bool | SetData (const wxDataFormat &format, size_t len, const void *buf)
| Set the data in the format format of the length len provided in the buffer buf. More...
bool | IsSupported (const wxDataFormat &format, Direction dir=Get) const
| Returns true if this format is supported. More...

## Additional Inherited Members
Public Types inherited from wxDataObject
enum | Direction { Get = 0x01 , Set = 0x02 , Both = 0x03 }

## Constructor & Destructor Documentation

## ◆ wxTextDataObject()

wxTextDataObject::wxTextDataObject | ( | const wxString & | text = `wxEmptyString` | ) |

Constructor, may be used to initialise the text (otherwise SetText() should be used later).

## Member Function Documentation

## ◆ GetAllFormats()

virtual void wxTextDataObject::GetAllFormats | ( | wxDataFormat * | formats,
|  | wxDataObject::Direction | dir = `wxDataObject::Get`
| ) |  | const
| virtual

Returns all the formats supported by wxTextDataObject.

Under wxMac and wxGTK they are `wxDF_TEXT` and `wxDF_UNICODETEXT`, under other ports returns only one of the two, depending on the build mode.

Implements wxDataObject.

## ◆ GetFormat()

const wxDataFormat& wxTextDataObject::GetFormat | ( |  | ) | const

Returns the preferred format supported by this object.

This is `wxDF_TEXT` or `wxDF_UNICODETEXT` depending on the platform.

## ◆ GetFormatCount()

virtual size_t wxTextDataObject::GetFormatCount | ( | wxDataObject::Direction | dir = `wxDataObject::Get` | ) | const
| virtual

Returns 2 under wxMac and wxGTK, where text data coming from the clipboard may be provided as ANSI (`wxDF_TEXT`) or as Unicode text (`wxDF_UNICODETEXT`).

Returns 1 under other platforms (e.g. wxMSW).

Implements wxDataObject.

## ◆ GetText()

virtual wxString wxTextDataObject::GetText | ( |  | ) | const
| virtual

Returns the text associated with the data object.

You may wish to override this method when offering data on-demand, but this is not required by wxWidgets' internals. Use this method to get data in text form from the wxClipboard.

## ◆ GetTextLength()

size_t wxTextDataObject::GetTextLength | ( |  | ) | const

Deprecated:

Don't use or call this function, it simply returns the length of the text plus one for compatibility purposes.

## ◆ SetText()

virtual void wxTextDataObject::SetText | ( | const wxString & | strText | ) |
| virtual

Sets the text associated with the data object.

This method is called when the data object receives the data and, by default, copies the text into the member variable. If you want to process the text on the fly you may wish to override this function.